/**
 * 错题本
 * @author: qingwu@iflytek.com
 * @date: 14-12-24
 * @time: 上午11:29
 */

var QuestionParse = QuestionParse || {};

$(function() {
	var _this = window;
	var conParseDiv = $(".container");

	/**
	 * 初始化界面
	 * @param json
	 * @param index
	 */
	_this.initialize = function(json, index) {
		if (json && json.length > 0) {
			paperParseDetail = json;
		} else {
			return;
		}
		_this.topicList
		if (paperParseDetail) {
			topicList = new QuestionParse.TopicParseList(paperParseDetail);
			topicList.init();
			changeTopic(index);
		}
	}
	//eventDispatcher.addEventListener('initialize', initialize);

	/**
	 * 加载相应题型解析界面
	 * @param index
	 */
	_this.changeTopic = function(index) {
		if ( typeof (topicList) !== "undefined" && topicList) {
			conParseDiv.empty();
			conParseDiv.append(topicList.getHtmlForIndex(index));
		}
	}
	/**
	 * 根据数据显示错误小题
	 * @param data
	 */
	_this.showErrorTopic = function(data) {
		conParseDiv.empty();
		if (!data) {
			return;
		}
		var topic = new QuestionParse.TopicParseModule(data);
		conParseDiv.append(topic.getHtml());
	}
	//eventDispatcher.addEventListener('changeTopic', loadTopicHtml);

	//initialize(errorData.result.list, 8);
	//commAdapter.callAndroid.getJsonData();
});

/**
 * 题型列表   初始化答题界面所有题型展示及事件
 */
QuestionParse.TopicParseList = (function() {

	/**
	 *  初始化
	 *  @topicList   作业详情
	 *  @topicObj    题型对象
	 */
	var TopicParseList = function(data) {
		this.topicList = data;
		this.topicObj = [];
	};

	/**
	 *  初始化题型列表-------保存题型列表
	 */
	TopicParseList.prototype.init = function() {
		var _this = this, i = 0, topic = {}, len = this.topicList.length;
		for (; i < len; i++) {
			topic = new QuestionParse.TopicParseModule(this.topicList[i]);
			topic.collectFn = function() {
				_this.collectFn();
			}
			topic.noteSubmitFn = function(param) {
				_this.noteSubmitFn(param);
			}
			_this.topicObj.push(topic);
		}
	};

	/**
	 * 获取答题界面所有题型界面Html
	 */
	TopicParseList.prototype.getHtml = function() {

		var i = 0, html = "", len = this.topicObj.length;
		for (; i < len; i++) {
			html += this.topicObj[i].getHtml(this.topicType);
		}

		return html;
	};

	/**
	 * 获取答题界面某小题的界面Html
	 */
	TopicParseList.prototype.getHtmlForIndex = function(index) {
		var html = this.topicObj[index].getHtml();
		return html;
	};

	/*
	 *  绑定题型相关点击选择事件
	 */
	TopicParseList.prototype.bindEvent = function() {

		var i = 0, len = this.topicObj.length;
		for (; i < len; i++) {
			this.topicObj[i].bindEvent();
		}

	};

	return TopicParseList;
})();

/**
 *
 * topicParseModule   答题解析Module
 *
 * 用于初始化题型
 */

QuestionParse.TopicParseModule = (function() {

	var TopicParseModule = function(data) {
		this.topicsDetail = data;

		this.knowledgeName = "";

		this.levelArr = ["", "20%", "40%", "60%", "80%", "100%"];
	};

	/**
	 * 获取题型HTML
	 */
	TopicParseModule.prototype.getHtml = function() {

		var html = "";
		this.formatData();
		//var _contentHtml = this.topicsDetail.contentHtml.replace(/700px/g,"100%").replace(/<img/g,"<img width='200px'");
		var _contentHtml = "";
		//处理table
		try {
			if (this.topicsDetail.content.material) {
				_contentHtml += "<div>";
				_contentHtml += this.topicsDetail.content.material;
				_contentHtml += "</div>";
				if (this.topicsDetail.content.accessories) {
					for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
						if (this.topicsDetail.content.accessories[i].desc === null || this.topicsDetail.content.accessories[i].desc === '')
							break;
						//显示小题题干
						_contentHtml += "<div>";
						_contentHtml += "(" + (i + 1) + ")";
						_contentHtml += this.topicsDetail.content.accessories[i].desc;
						_contentHtml += "</div>";
						if (this.topicsDetail.content.accessories[i].options) {
							//显示小题题号
							_contentHtml += "<div>";
							for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
								_contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
								_contentHtml += ".";
								_contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
								_contentHtml += "<br>";
							}
							_contentHtml += "</div>";
						}
					}
					//_contentHtml +=this.topicsDetail.content.material;
				}
			} else if (this.topicsDetail.content.accessories) {
				for (var i = 0; i < this.topicsDetail.content.accessories.length; i++) {
					//显示小题题干
					_contentHtml += "<div>";
					_contentHtml += this.topicsDetail.content.accessories[i].desc;
					_contentHtml += "</div>";
					if (this.topicsDetail.content.accessories[i].options) {
						//显示小题题号
						_contentHtml += "<div>";
						for (var j = 0; j < this.topicsDetail.content.accessories[i].options.length; j++) {
							_contentHtml += this.topicsDetail.content.accessories[i].options[j].id;
							_contentHtml += ".";
							_contentHtml += this.topicsDetail.content.accessories[i].options[j].desc;
							_contentHtml += "<br>";
						}
						_contentHtml += "</div>";
					}
				}
			} else {
				_contentHtml = this.topicsDetail.contentHtml;
			}

			_contentHtml = _contentHtml.replace(/700px/g, "100%");
			//.replace(/<img/g,"<img width='100%'");
			this.topicsDetail.answerHtml = this.topicsDetail.answerHtml.replace(/700px/g, "100%");
			this.topicsDetail.analysisHtml = this.topicsDetail.analysisHtml.replace(/700px/g, "100%");
		} catch (e) {

		}

		// html += __templTopics__({"topics": this.topicsDetail, "basePath": this.basePath, "total": _total, "contentHtml": _contentHtml});
		html += this.getTemplTopicHtml({
			"topics" : this.topicsDetail,
			"contentHtml" : _contentHtml
		});
		return html;
	};

	TopicParseModule.prototype.getTemplTopicHtml = function(templdata) {
		var html = "";
		html += getTopicParse();
		return html;

		//获取题干
		function getTopicParse() {
			//题干
			var html = getTopicContent();
			html += getTopicMyAnswer();
			html += getTopicAnswer();
			html += getTopocAnalysis();
			html += getKnowledge();
			return html;
		}

		//获取题面
		function getTopicContent() {
			//qingwu:在题目超出屏宽时支持题目横向滑动
			var html = "<div class='subject'><div style='overflow: auto'><div class='bd'>" + templdata.contentHtml + "</div></div></div>";
			html += "<div class='line'></div><div class='clear'></div>";
			return html;
		}

		//获取我的答案
		function getTopicMyAnswer() {
			html = "<div class='my_ans clear'><div class='hd clearfix'><div class='fl'><i class='fl'><img src='../images/icon2.png' width='15' height='19'></i><span class='fl'>我的答案</span></div>" + "<span  class='fr' >(得分" + templdata.topics.wrongTopicRecordArchive.userScore + "/满分" + templdata.topics.wrongTopicRecordArchive.standardScore + "分)</span></div><div class='bd clearfix'>"

			if (templdata.topics.wrongTopicRecordArchive.answerType === 's01Text') {
				if (!templdata.topics.wrongTopicRecordArchive.userAnswer || templdata.topics.wrongTopicRecordArchive.userAnswer === "null" || templdata.topics.wrongTopicRecordArchive.userAnswer === null || templdata.topics.wrongTopicRecordArchive.userAnswer === "")
					html += "<p style='color:red;'>未答题</p>";
				else if (templdata.topics.wrongTopicRecordArchive.userAnswer === "1")
					html += "会";
				else if (templdata.topics.wrongTopicRecordArchive.userAnswer === "0")
					html += "不会";
				else if (templdata.topics.wrongTopicRecordArchive.smallTopicUserAnswers) {
					var length = templdata.topics.wrongTopicRecordArchive.smallTopicUserAnswers.length;
					html += "<p>";
					if (length === 1) {
						html += templdata.topics.wrongTopicRecordArchive.smallTopicUserAnswers[0].userAnswer;
					} else {
						var tableCount = 1;
						if (length >= 10 && length % 10 === 0) {
							tableCount = parseInt(length / 10);
						} else {
							tableCount += parseInt(length / 10);
						}

						for (var num = 0; num < tableCount; num++) {
							html += "<table style='border: 1px solid #CCCCCC;border-collapse:collapse;' width='100%'>";
							var answerLength = 10;
							var startIndex = num * 10;
							if (num + 1 >= tableCount) {
								answerLength = length - startIndex;
							}
							var endIndex = startIndex + answerLength;
							//题号
							html += "<tr style='border: 1px solid  #CCCCCC;text-align:center'>" + "<td style='border: 1px solid  #CCCCCC;width:35px' >题号</td>";
							var width = 630 / answerLength;
							for (var i = startIndex; i < endIndex; i++) {
								html += "<td style='border: 1px solid  #CCCCCC;' width='" + width + "px'>" + templdata.topics.wrongTopicRecordArchive.smallTopicUserAnswers[i].topicNum + "</td>"
							}
							html += "</tr>";

							//答案
							html += "<tr style='border: 1px solid #CCCCCC;text-align:center'>" + "<td style='border: 1px solid  #CCCCCC;'>答案</td>";
							for (var i = startIndex; i < endIndex; i++) {
								var answer = templdata.topics.wrongTopicRecordArchive.smallTopicUserAnswers[i];
								html += "<td style='border: 1px solid  #CCCCCC;'>";
								if (answer.isCorrect === "true" || answer.isCorrect === true) {
									html += "<font style='color:#3A926A'>" + answer.userAnswer + "</font>";
								} else {
									var useranswer = answer.userAnswer;
									if (!useranswer)
										useranswer = "不会";
									html += "<font style='color:#BA5656'>" + useranswer + "</font>";
								}

								html += "</td>"
							}
							html += "</tr>";
							html += "</table>";
							if (num + 1 < tableCount)
								html += "<br/>";
						}
					}
					html += "</p>";
				} else
					html += "<p>" + templdata.topics.wrongTopicRecordArchive.userAnswer + "</p>";
			} else if (templdata.topics.wrongTopicRecordArchive.imageAnswers) {
				html += "<p>";

				for (var i = 0, length = templdata.topics.wrongTopicRecordArchive.imageAnswers.length; i < length; i++) {
					html += "<p><img  onclick='commAdapter.callAndroid.showPhoto(\"" + templdata.topics.wrongTopicRecordArchive.imageAnswers[i] + "\");' class='zx_answer' src=" + templdata.topics.wrongTopicRecordArchive.imageAnswers[i] + " alt='' style='width: 100%;' /> </p>";
				}
				html += "</p>"
			}

			html += " </div></div>";
			html += "<div class='line'></div>";

			return html;
		}

		//获取知识点
		function getKnowledge() {
			if (!templdata.topics.knowledgeName || templdata.topics.knowledgeName === null || templdata.topics.knowledgeName === '')
				return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon5.png' width='19' height='19'></i><span class='fl'>知识点：</span></div></div>"
			return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon5.png' width='19' height='19'></i><span class='fl'>知识点：" + templdata.topics.knowledgeName + "</span></div></div>"
		}

		//获取正确答案
		function getTopicAnswer() {
			return "<div class='correct'><div class='hd'><i class='fl'><img src='../images/icon3.png' width='19' height='19'></i><span class='fl'>正确答案</span>" + "</div><div class='bd' style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.answerHtml + "</div></div><div class='line'></div><div class='clear'></div>";
		}

		//获取试题解析
		function getTopocAnalysis() {
			return "<div class='answer'><div class='hd ft16'><i class='fl'><img src='../images/icon4.png' width='19' height='19'></i><span class='fl'>试题解析</span></div>" + "<div class='bd'  style='overflow:auto;table-layout:fixed;word-break:break-all;'>" + templdata.topics.analysisHtml + "</div></div><div class='line'></div><div class='clear'></div>";
		}

	}
	/**
	 *  格式化数据
	 */
	TopicParseModule.prototype.formatData = function() {
		if (this.topicsDetail.wrongTopicRecordArchive.relatedKnowledgeGroups && this.topicsDetail.wrongTopicRecordArchive.relatedKnowledgeGroups.length > 0) {
			if (this.topicsDetail.wrongTopicRecordArchive.relatedKnowledgeGroups[0].relatedKnowledges && this.topicsDetail.wrongTopicRecordArchive.relatedKnowledgeGroups[0].relatedKnowledges.length > 0) {
				this.topicsDetail.knowledgeName = this.topicsDetail.wrongTopicRecordArchive.relatedKnowledgeGroups[0].relatedKnowledges[0].name;
			}
		}
		this.topicsDetail.level = this.levelArr[this.topicsDetail.wrongTopicRecordArchive.difficultyValue];

	};

	/**
	 *  绑定页面元素点击事件
	 */
	TopicParseModule.prototype.bindEvent = function() {

	};

	return TopicParseModule;
})();
