/**
 * Created with JetBrains WebStorm.
 * User: xlzhou2@iflytek.com
 * Date: 14-2-21
 * Time: 下午3:43
 * To change this template use File | Settings | File Templates.
 */


/**
 * 利用占位符格式化字符串
 * 例如："你好，{0}, {1}".format('aa', 'Nice to meet you!') = "你好，aa Nice to meet you!";
 */
String.prototype.format = function () {
    var s = this, i = arguments.length;

    while (i--) {
        s = s.replace(new RegExp('\\{' + i + '\\}', 'gm'), arguments[i]);
    }
    return s;
};


/**
 * 截获URL参数
 * @type {{QueryString: Function}}
 */
var Request = {
    //获取URL参数
    QueryString: function (item) {
        var svalue = location.search.match(new RegExp("[\?\&]" + item + "=([^\&]*)(\&?)", "i"));
        return svalue ? svalue[1] : svalue;
    },

    /**
     * url 目标url
     * arg 需要替换的参数名称
     * arg_val 替换后的参数的值
     * return url 参数替换后的url
     */
    changeURLArg: function (url, arg, arg_val) {
        var pattern = arg + '=([^&]*)';
        var replaceText = arg + '=' + arg_val;
        if (url.match(pattern)) {//如果没有此参数，添加
            var tmp = '/(' + arg + '=)([^&]*)/gi';
            tmp = url.replace(eval(tmp), replaceText);
            return tmp;
        } else {//如果有此参数，修改
            if (url.match('[\?]')) {
                return url + '&' + replaceText;
            } else {
                return url + '?' + replaceText;
            }
        }
        return url + '\n' + arg + '\n' + arg_val;
    },

    /**
     *
     * @param url 目标url
     * @param params 参数对象，可是是多个
     *                 格式如：[{arg:01,arg_val:11},{arg:00,arg_val:12}]
     */
    changeURLArgs:function(url,params){
        var lastPattern ="";
         for(var item in params){
             var pattern = params[item].arg + '=([^&]*)';
             var replaceText = params[item].arg + '=' + params[item].arg_val;
             if (url.match(pattern)) {//如果没有此参数，添加
                 var tmp = '/(' + params[item].arg + '=)([^&]*)/gi';
                 tmp = url.replace(eval(tmp), replaceText);
                 return tmp;
             } else {//如果有此参数，修改
                 if (url.match('[\?]')) {
                     return url + '&' + replaceText;
                 } else {
                     return url + '?' + replaceText;
                 }
             }
         }
    },

    /**
     * 去除指定的url参数
     * @param url
     * @param param
     * @returns {*}
     */
    cutURLParam: function (url, param) {
        var url1 = url;
        if (url.indexOf(param) > 0) {
            if (url.indexOf("&", url.indexOf(param) + param.length) > 0) {
                url1 = url.substring(0, url.indexOf(param)) + url.substring(url.indexOf("&", url.indexOf(param) + param.length) + 1);
            }
            else {
                url1 = url.substring(0, url.indexOf(param) - 1);
            }
            return url1;
        }
        else {
            return url1;
        }
    }


}

/**
 * 格式化时间戳显示
 * @param x 待显示的日期时间，例如new Date()
 * @param y 需要显示的格式，例如"yyyy-MM-dd hh:mm:ss"
 * @returns {XML|string}
 * @example dateFormat(new Date(), "yyyy-MM-dd hh:mm:ss")
 *          或 dateFormat(new Date(1392912000 * 1000),"yyyy/MM/dd hh:mm:ss") 结果为 "2014/02/21 00:00:00"
 */
function dateFormat(x, y) {
    var z = {M: x.getMonth() + 1, d: x.getDate(), h: x.getHours(), m: x.getMinutes(), s: x.getSeconds()};
    y = y.replace(/(M+|d+|h+|m+|s+)/g, function (v) {
        return ((v.length > 1 ? "0" : "") + eval('z.' + v.slice(-1))).slice(-2)
    });
    return y.replace(/(y+)/g, function (v) {
        return x.getFullYear().toString().slice(-v.length)
    });
}


/**
 * 警告提示框
 * @param title    标题
 * @param content  内容
 * @param isLock   开启锁屏。 中断用户对话框之外的交互，用于显示非常重要的操作/消息，所以不建议频繁使用它，它会让操作变得繁琐
 */
function dialogBox(title, content, isLock) {
    art.dialog({
        lock: isLock,
        background: 'gray', // 背景色
        title: title,
        content: content,
        ok: true,
        okVal: '确定'
    });
}

/**
 * 确定提示框
 * @param title    标题
 * @param content  内容
 * @param okCallBack 确定后回调
 * @param cancelCallBack 取消后回调
 * @param isLock   开启锁屏。 中断用户对话框之外的交互，用于显示非常重要的操作/消息，所以不建议频繁使用它，它会让操作变得繁琐
 */
function confirmBox(title, content, okCallBack, cancelCallBack, isLock) {
    art.dialog({
        lock: isLock ? false : true,
        background: 'gray', // 背景色
        title: title,
        content: content,
        ok: function () {
            if (typeof okCallBack == "function") {
                okCallBack();
            }
        },
        okVal: '确定',
        cancelVal: '关闭',
        cancel: function () {
            if (typeof cancelCallBack == "function") {
                cancelCallBack();
            }
        }
    });
}

/**
 * 格式化时间类
 */
var DateFormat = (function () {
    /**
     * 构造函数
     * @param type time的类型 0:Unix时间戳格式 1:日期时间格式
     * @param time Unix时间戳格式 如：1393579588； 日期时间格式 如：2014-02-28 17:26:28
     * @constructor
     */
    var DateFormat = function (type, time) {
        switch (type) {
            case 0: // 时间戳格式
                this.timestamp = time;
                break;
            case 1: // 日期时间格式
                this.timestamp = parseInt(this.toTimeStamp(time));
                break;
            default :
                break;
        }
        this.formatDateTime = null;
    };

    /**
     * 格式化显示时间日期
     * @param time Unix时间戳格式, 如：1393579588
     * @param format 希望的时间格式，如:"yyyy-MM-dd hh:mm:ss"
     * @returns string 格式化后的时间字符串
     */
    DateFormat.prototype.toDateTime = function (time, format) {
        var x = new Date(parseInt(time)),
            y = format;
        var z = {M: x.getMonth() + 1, d: x.getDate(), h: x.getHours(), m: x.getMinutes(), s: x.getSeconds()};
        y = y.replace(/(M+|d+|h+|m+|s+)/g, function (v) {
            return ((v.length > 1 ? "0" : "") + eval('z.' + v.slice(-1))).slice(-2)
        });
        this.formatDateTime = y.replace(/(y+)/g, function (v) {
            return x.getFullYear().toString().slice(-v.length)
        });
        return this.formatDateTime;
    };

    /**
     * 获取日期时间的时间戳
     * @param datetime 格式为"2014-03-03 09:36:00"
     * @returns {Number} 时间戳
     */
    DateFormat.prototype.toTimeStamp = function (datetime) {
        var dateAndTime = datetime.split(' ');
        var date = dateAndTime[0].split('-');
        //如果时间格式没有传递时分秒，在下面补上
        if (dateAndTime.length == 1) {
            dateAndTime.push("00:00:00");
        }
        var time = dateAndTime[1].split(':');
        return parseInt(new Date(date[0], date[1] - 1, date[2], time[0], time[1], time[2]).getTime());
    };

    /**
     * 获取一个时间段的开始时间和结束时间时间戳
     * @param days 向后多少天，如为向前，则为负数
     * @returns {{beginTime: Number, endTime: Number}}
     */
    DateFormat.prototype.getDateInterval = function (days) {
        var anotherTime = parseInt(this.timestamp) + 60 * 60 * 24 * 1000 * days;
        if (days > 0) {
            var beginTime = this.toTimeStamp(this.toDateTime(this.timestamp, 'yyyy-MM-dd') + " 00:00:00");
            var endTime = this.toTimeStamp(this.toDateTime(anotherTime, 'yyyy-MM-dd') + " 23:59:59");
        } else {
            var beginTime = this.toTimeStamp(this.toDateTime(anotherTime, 'yyyy-MM-dd') + " 00:00:00");
            var endTime = this.toTimeStamp(this.toDateTime(this.timestamp, 'yyyy-MM-dd') + " 23:59:59");
        }
        var dateInterval = {
            "beginTime": beginTime,
            "endTime": endTime
        };
        return dateInterval;
    };

    return DateFormat;
})();


/**
 * 获取本周、本月的开端日期、停止日期
 */

var GetWeekMouth = (function () {

    var GetWeekMouth = function (date) {
        if (date == undefined) {
            this.now = new Date(); //当前日期
        } else {
            this.now = new Date(date); //当前日期
        }

        //将本周的开始时间设置为周一，结束时间设置为周日
        this.nowDayOfWeek = this.now.getDay(); //今天本周的第几天
        if(this.nowDayOfWeek==0){
            this.nowDayOfWeek =6;
        }else if(this.nowDayOfWeek==6){
            this.nowDayOfWeek=1;
        }else{
            this.nowDayOfWeek--;
        }

        this.nowDay = this.now.getDate(); //当前日
        this.nowMonth = this.now.getMonth(); //当前月
        this.nowYear = this.now.getYear(); //当前年
        this.nowYear += (this.nowYear < 2000) ? 1900 : 0; //
        this.lastMonthDate = new Date(); //上月日期
        this.lastMonthDate.setDate(1);
        this.lastMonthDate.setMonth(this.lastMonthDate.getMonth() - 1);
    };

    //格局化日期：yyyy-MM-dd
    GetWeekMouth.prototype.formatDate = function (date) {
        var myyear = date.getFullYear();
        var mymonth = date.getMonth() + 1;
        var myweekday = date.getDate();

        if (mymonth < 10) {
            mymonth = "0" + mymonth;
        }
        if (myweekday < 10) {
            myweekday = "0" + myweekday;
        }
        return (myyear + "-" + mymonth + "-" + myweekday);
    };

    //获得本周的开端日期
    GetWeekMouth.prototype.getWeekStartDate = function () {
        var weekStartDate = new Date(this.nowYear, this.nowMonth, this.nowDay - this.nowDayOfWeek);
        return this.formatDate(weekStartDate);
    };

    //获得本周的停止日期
    GetWeekMouth.prototype.getWeekEndDate = function () {
        var weekEndDate = new Date(this.nowYear, this.nowMonth, this.nowDay + (6 - this.nowDayOfWeek));
        return this.formatDate(weekEndDate);
    };

    //获得本月的开端日期
    GetWeekMouth.prototype.getMonthStartDate = function () {
        var monthStartDate = new Date(this.nowYear, this.nowMonth, 1);
        return this.formatDate(monthStartDate);
    };

    //获得本月的停止日期
    GetWeekMouth.prototype.getMonthEndDate = function () {
        var monthEndDate = new Date(this.nowYear, this.nowMonth, this.getMonthDays(this.nowMonth));
        return this.formatDate(monthEndDate);
    };

    //获得某月的天数
    GetWeekMouth.prototype.getMonthDays = function (myMonth) {
        var monthStartDate = new Date(this.nowYear, myMonth, 1);
        var monthEndDate = new Date(this.nowYear, myMonth + 1, 1);
        var days = (monthEndDate - monthStartDate) / (1000 * 60 * 60 * 24);
        return days;
    };

    return GetWeekMouth;
})();

/**
 * 截取含有汉字的字符串
 *
 * @param str
 *            ：字符串 len ：截取长度 hasDot：是否需要添加省略号（true或false）
 * @author hlwang3
 */
function interceptString(str, len, hasDot) {
    if (str == "" || str == undefined) {
        return "";
    }
    var newLength = 0, newStr = "",
        chineseRegex = /[^\x00-\xff]/g, singleChar = "",
        strLength = str.replace(chineseRegex, "**").length;

    if (strLength <= len) {
        return str;
    }
    if (hasDot) {
        len = len - 2;
    }
    for (var i = 0; i < strLength; i++) {
        singleChar = str.charAt(i).toString();
        if (singleChar.match(chineseRegex) != null) {
            newLength += 2;
        } else {
            newLength++;
        }
        if (newLength > len) {
            break;
        }
        newStr += singleChar;
    }
    if (hasDot) {
        newStr += "...";
    }
    return newStr;
}
var CommonDialog = {
    /**
     * 异步加载页面
     * @param title
     * @param url
     * @param callback
     * @param options
     */
    load:function(title,url,callback,options){
        options = options || {};
        var d = art.dialog({
            title: title,
            content: "",
            backdropBackground: "gray",
            backdropOpacity: 0.4,
            width: options.width || 990,
            height: options.height || 577,
            lock: true,
            resize: false,
            drag:false,
            fixed:true
        });
        $(d.DOM.content[0]).load(url,callback);
    },
    /**
     * artDialog 锁屏
     */
    lock: function () {
        var content = '数据获取中，请稍后...';
        if (arguments[0] == "commit") {
            content = '数据提交中，请稍后...';
        } else if (arguments[0] == "check") {
            content = '数据检测中，请稍后...';
        }
        var d = art.dialog({
            lock: true,
            background: 'black', // 背景色
            opacity: 0.7,	// 透明度
            content: content,
            fixed:true,
            cancel: false
        });
        return d;
        //d.showModal();
    },

    /**
     * artDialog 关闭（全部关闭）
     */
    close: function () {
        var list = art.dialog.list;
        for (var i in list) {
            list[i].close();
        }
    },

    /**
     * 暂停练习
     * @param title
     * @param content
     * @param okCallback
     */
    stop: function (title, content, okCallback) {
        var d = art.dialog({
            title: title,
            content: content,
            backdropBackground: "white",
            backdropOpacity: 1,
            ok: function () {
                if (typeof  okCallback === "function") {
                    var res = okCallback();
                    if (res == false) {
                        return false;
                    }
                }
            },
            cancel:false,
            okValue: '确定',
            width: 300,
            height:150,
            drag:false,
            esc:false,
            resize: false,
            fixed:true,
            lock: true
        });
        //d.showModal();
    },

    /**
     * 一般弹框
     * @param title
     * @param content
     * @param callback
     */
    normal: function (title,content,callback) {
        var d = art.dialog({
            title: title,
            content: content,
            backdropBackground: "gray",
            backdropOpacity: 0.5,
            ok: function () {
                if (typeof  callback === "function") {
                    setTimeout(callback,100);
                    return true;
                }else{
                    return true;
                }
            },
            close: function () {
                if (typeof  callback === "function") {
                    setTimeout(callback,100);
                    return true;
                }else{
                    return true;
                }
            },
            okValue: '确定',
            width: 300,
            height:150,
            drag:false,
            fixed:true,
            lock: true
        });
        //d.showModal();
    },

    /**
     * 一般弹框
     * @param title
     * @param content
     * @param callback
     */
    show: function (title,content,callback) {
        var d = art.dialog({
            title: title,
            content: content,
            backdropBackground: "gray",
            backdropOpacity: 0.5,
            ok: function () {
                if (typeof  callback === "function") {
                    setTimeout(callback,100);
                    return true;
                }else{
                    return true;
                }
            },
            close: function () {
                if (typeof  callback === "function") {
                    setTimeout(callback,100);
                    return true;
                }else{
                    return true;
                }
            },
            okValue: '确定',
            drag:false,
            fixed:true,
            lock: true
        });
        //d.showModal();
    },

    /**
     * 页面提示消息
     * @param content
     * @param time
     */
    tips:function(content,time){
//        var d = art.dialog({
//            background: 'black', // 背景色
//            content: content,
//            cancel: false,
//            title:false,
//            fixed:true
//        });
//        d.time(time || 1);
        var tips = $("<div style='position: fixed;padding-left: 10px;padding-right: 10px;left: 50%;top: 50%;height: 50px;background: white;border: 1px solid rgb(148, 148, 148);min-width: 100px;text-align: center;line-height: 50px;z-index: 9000;'></div>");
        $("body").append(tips);
        tips.text(content);
        tips.css({"margin-left":"-"+tips.width()/2+"px"});
        //console.log(tips.width());
        setTimeout(function(){
            tips.remove();
        },time*1000 || 1000);
    }
};

//计算字符串长度
String.prototype.strLen = function() {
    var len = 0;
    for (var i = 0; i < this.length; i++) {
        if (this.charCodeAt(i) > 255 || this.charCodeAt(i) < 0) len += 2; else len ++;
    }
    return len;
}
//将字符串拆成字符，并存到数组中
String.prototype.strToChars = function(){
    var chars = new Array();
    for (var i = 0; i < this.length; i++){
        chars[i] = [this.substr(i, 1), this.isCHS(i)];
    }
    String.prototype.charsArray = chars;
    return chars;
}
//判断某个字符是否是汉字
String.prototype.isCHS = function(i){
    if (this.charCodeAt(i) > 255 || this.charCodeAt(i) < 0)
        return true;
    else
        return false;
}
//截取字符串（从start字节到end字节）
String.prototype.subCHString = function(start, end){
    var len = 0;
    var str = "";
    this.strToChars();
    for (var i = 0; i < this.length; i++) {
        if(this.charsArray[i][1])
            len += 2;
        else
            len++;
        if (end < len)
            return str;
        else if (start < len)
            str += this.charsArray[i][0];
    }
    return str;
}

